from telethon.tl.mtproto_request import MTProtoRequest


class PhoneCallDiscarded(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    phoneCallDiscarded#50ca4de1 flags:None id:long reason:flags.0?PhoneCallDiscardReason duration:flags.1?int = PhoneCall"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x50ca4de1

    def __init__(self, id, reason=None, duration=None):
        """
        :param id: Telegram type: «long».
        :param reason: Telegram type: «PhoneCallDiscardReason».
        :param duration: Telegram type: «int».
        """
        super().__init__()

        self.id = id
        self.reason = reason
        self.duration = duration

    def on_send(self, writer):
        writer.write_int(PhoneCallDiscarded.constructor_id, signed=False)
        # Calculate the flags. This equals to those flag arguments which are NOT None
        flags = 0
        flags |= (1 << 0) if self.reason else 0
        flags |= (1 << 1) if self.duration else 0
        writer.write_int(flags)

        writer.write_long(self.id)
        if self.reason:
            self.reason.on_send(writer)

        if self.duration:
            writer.write_int(self.duration)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return PhoneCallDiscarded(None, None, None)

    def on_response(self, reader):
        flags = reader.read_int()

        self.id = reader.read_long()
        if (flags & (1 << 0)) != 0:
            self.reason = reader.tgread_object()

        if (flags & (1 << 1)) != 0:
            self.duration = reader.read_int()

    def __repr__(self):
        return 'phoneCallDiscarded#50ca4de1 flags:None id:long reason:flags.0?PhoneCallDiscardReason duration:flags.1?int = PhoneCall'

    def __str__(self):
        return '(phoneCallDiscarded (ID: 0x50ca4de1) = (id={}, reason={}, duration={}))'.format(str(self.id), str(self.reason), str(self.duration))
